function Initialize()
   local t = os.time()
   while t == os.time() do end
   z = math.fmod(os.clock(), 1)
   startTime, stopTime, setTime, mode = SKIN:GetVariable('Zero') ~= '' and os.clock() - os.time() + tonumber(SKIN:GetVariable('Zero')) or nil, tonumber(SKIN:GetVariable('Stop')) or 0, tonumber(SKIN:GetVariable('Set')), true
   if SKIN:GetVariable('Mode') == '0' then
      SetMode(0)
   end
end

function Update()
   if mode then
      return string.format('    `%s.%03u', os.date('%H:%M:%S'), math.fmod(os.clock() - z, 1) * 1000)
   elseif startTime then
      local t = os.clock() - startTime
      local sign = t < 0 and '-' or '+'
      t = math.abs(t)
      return string.format('%s%03u.%02u:%02u:%06.3f', sign, t / 86400, t / 3600 % 24, t / 60 % 60, t % 60)
   elseif stopTime == 0 then
      local t, sign = math.abs(setTime), setTime < 0 and '-' or '+'
      return string.format('%s%03u.%02u:%02u:%06.3f', sign, t / 86400, t / 3600 % 24, t / 60 % 60, t % 60)
   else
      local t, sign = math.abs(stopTime), stopTime < 0 and '-' or '+'
      return string.format('%s%03u.%02u:%02u:%06.3f', sign, t / 86400, t / 3600 % 24, t / 60 % 60, t % 60)
   end
end

function SetMode(n)
   if mode or n then
      mode = false
      SKIN:Bang('[!SetOption Time1 Text #*Mark*#][!SetOptionGroup TimerButtons FontColor #*Color*#][!SetOptionGroup TimerButtons StringEffect #*Effect*#][!SetOption StartSplit LeftMouseDownAction "!CommandMeasure mScript '..(startTime and 'Split' or 'Start')..'()"][!SetOption StopReset LeftMouseDownAction "!CommandMeasure mScript '..(startTime and 'Stop' or 'Reset')..'()"][!WriteKeyValue Variables Mode 0 "#@#Settings.inc"][!UpdateMeterGroup All]')
      if not startTime and stopTime == 0 then
         SKIN:Bang('!ShowMeterGroup TimerSet')
      end
   else
      mode = true
      SKIN:Bang('[!SetOption Time1 Text ""][!SetOptionGroup TimerButtons FontColor #*ColorDim*#][!SetOptionGroup TimerButtons StringEffect ""][!SetOptionGroup TimerButtons LeftMouseDownAction ""][!HideMeterGroup TimerSet][!WriteKeyValue Variables Mode 1 "#@#Settings.inc"][!UpdateMeterGroup All]')
   end
end

function SetSize(n)
   local size = tonumber(SKIN:GetVariable('Size')) + n
   if size > 0 and size < 21 then
      SKIN:Bang('[!SetOption Time2 FontSize '..(20 * size)..'][!SetVariable Size '..size..'][!WriteKeyValue Variables Size '..size..' "#@#Settings.inc"][!UpdateMeterGroup All]')
   end
end

function Add(n)
   setTime = setTime + n
   SKIN:Bang('!WriteKeyValue Variables Set '..setTime..' "#@#Settings.inc"')
end

function Start()
   startTime, setTime = os.clock() - setTime - stopTime, 0
   SKIN:Bang('[!SetOption StartSplit LeftMouseDownAction "!CommandMeasure mScript Split()"][!SetOption StopReset LeftMouseDownAction "!CommandMeasure mScript Stop()"][!UpdateMeterGroup TimerButtons][!HideMeterGroup TimerSet][!WriteKeyValue Variables Zero '..(os.time() - math.floor(os.clock()) - z + startTime)..' "#@#Settings.inc"][!WriteKeyValue Variables Set 0 "#@#Settings.inc"]')
end

function Split()
   local t = os.clock() - startTime
   local sign = t < 0 and '-' or '+'
   t = math.abs(t)
   t = string.format('%s%03u.%02u:%02u:%06.3f', sign, t / 86400, t / 3600 % 24, t / 60 % 60, t % 60)
   SKIN:Bang('[!SetVariable Mark '..t..'][!UpdateMeter Time1][!WriteKeyValue Variables Mark '..t..' "#@#Settings.inc"]')
end

function Stop()
   stopTime, startTime = os.clock() - startTime, nil
   SKIN:Bang('[!SetOption StartSplit LeftMouseDownAction "!CommandMeasure mScript Start()"][!SetOption StopReset LeftMouseDownAction "!CommandMeasure mScript Reset()"][!UpdateMeterGroup TimerButtons][!WriteKeyValue Variables Zero "" "#@#Settings.inc"][!WriteKeyValue Variables Stop '..stopTime..' "#@#Settings.inc"]')
end

function Reset()
   stopTime, setTime = 0, 0
   SKIN:Bang('[!SetVariable Mark +000.00:00:00.000][!UpdateMeter Time1][!ShowMeterGroup TimerSet][!WriteKeyValue Variables Stop "" "#@#Settings.inc"][!WriteKeyValue Variables Set 0 "#@#Settings.inc"][!WriteKeyValue Variables Mark +000.00:00:00.000 "#@#Settings.inc"]')
end
